/**********************************************************************************************************************
 * DISCLAIMER
 * This software is supplied by Renesas Electronics Corporation and is only intended for use with Renesas products. No
 * other uses are authorized. This software is owned by Renesas Electronics Corporation and is protected under all
 * applicable laws, including copyright laws.
 * THIS SOFTWARE IS PROVIDED "AS IS" AND RENESAS MAKES NO WARRANTIES REGARDING
 * THIS SOFTWARE, WHETHER EXPRESS, IMPLIED OR STATUTORY, INCLUDING BUT NOT LIMITED TO WARRANTIES OF MERCHANTABILITY,
 * FITNESS FOR A PARTICULAR PURPOSE AND NON-INFRINGEMENT. ALL SUCH WARRANTIES ARE EXPRESSLY DISCLAIMED. TO THE MAXIMUM
 * EXTENT PERMITTED NOT PROHIBITED BY LAW, NEITHER RENESAS ELECTRONICS CORPORATION NOR ANY OF ITS AFFILIATED COMPANIES
 * SHALL BE LIABLE FOR ANY DIRECT, INDIRECT, SPECIAL, INCIDENTAL OR CONSEQUENTIAL DAMAGES FOR ANY REASON RELATED TO
 * THIS SOFTWARE, EVEN IF RENESAS OR ITS AFFILIATES HAVE BEEN ADVISED OF THE POSSIBILITY OF SUCH DAMAGES.
 * Renesas reserves the right, without notice, to make changes to this software and to discontinue the availability of
 * this software. By using this software, you agree to the additional terms and conditions found by accessing the
 * following link:
 * http://www.renesas.com/disclaimer
 *
 * Copyright (C) 2020-2022 Renesas Electronics Corporation. All rights reserved.
 *********************************************************************************************************************/
/***********************************************************************/
/*                                                                     */
/*  FILE        :Main.c or Main.cpp                                    */
/*  DATE        :2023/06/30                                            */
/*  DESCRIPTION :Main Program                                          */
/*  CPU TYPE    :R5F10268                                              */
/*                                                                     */
/***********************************************************************/

/***********************************************************************
Includes
************************************************************************/
#include "r_cg_macrodriver.h"
//#include "Config_CSI00.h"
#include "Config_IT.h"
/* Start user code for include. Do not edit comment generated here */
#include "r_CSI_lib.h"

/* End user code. Do not edit comment generated here */
#include "r_cg_userdefine.h"


/***********************************************************************
Global variables and functions
***********************************************************************/

/*  MA7219̓WX^̃AhX\  */
#define No_OP   ( 0x00 )            // m[EIy[ṼAhX
#define Digit0  ( 0x01 )            // fWbg0̃AhX
#define Digit1  ( 0x02 )            // fWbg1̃AhX
#define Digit2  ( 0x03 )            // fWbg2̃AhX
#define Digit3  ( 0x04 )            // fWbg3̃AhX
#define Digit4  ( 0x05 )            // fWbg4̃AhX
#define Digit5  ( 0x06 )            // fWbg5̃AhX
#define Digit6  ( 0x07 )            // fWbg6̃AhX
#define Digit7  ( 0x08 )            // fWbg7̃AhX
#define DecMode ( 0x09 )            // \pfR[_̃[hw
#define Intend  ( 0x0A )            // \LEDPxݒ
#define ScanL   ( 0x0B )            // \XLݒ
#define ShutD   ( 0x0C )            // VbgE_E
#define DispT   ( 0x0F )            // fBXvCEeXg

#define LEDDIG  ( 0x04 )            // LEĎi4j

#define LED1    ( P2_bit.no0 )      // USER LED1 of RL78/G15-FPB
#define LED2    ( P2_bit.no1 )      // USER LED2 of RL78/G15-FPB
#define USER_SW ( P13_bit.no7 )     // USER SW of RL78/G15-FPB

uint8_t const INIT1[9][4] =
{   // MAX7219̐ݒR}h : {AhX,p[^}

    {DispT,0x00,DispT,0x00},        // ʏ퓮
    {ShutD,0x01,ShutD,0x01},        // X^oCR}h
    {DecMode,0x00,DecMode,0x00},    // fR[hE[hݒR}h
    {Intend,0x03,Intend,0x03},      // LEDPxݒR}h(7/32)
    {ScanL,0x07,ScanL,0x07},        // XLΏیݒiS8j
    {No_OP,0x00,No_OP,0x00},        // m[EIy[V
    {No_OP,0x00,No_OP,0x00},        // m[EIy[V
    {No_OP,0x00,No_OP,0x00},        // m[EIy[V
    {No_OP,0x00,No_OP,0x00}         // m[EIy[V

};


uint8_t const FONT_DATA[32][8] =
{   /* MAX7219p\f[^z  */
    {0x0E,0x11,0x11,0x11,0x11,0x11,0x0E,0x00},  // 00: O ̃tHg
    {0x0E,0x04,0x04,0x04,0x04,0x06,0x04,0x00},  // 01: P ̃tHg
    {0x1F,0x02,0x04,0x08,0x10,0x11,0x0E,0x00},  // 02: Q ̃tHg
    {0x0E,0x11,0x10,0x08,0x04,0x08,0x1F,0x00},  // 03: R ̃tHg
    {0x08,0x08,0x1F,0x09,0x0A,0x0C,0x08,0x00},  // 04: S ̃tHg
    {0x0E,0x11,0x10,0x10,0x0F,0x01,0x1F,0x00},  // 05: T ̃tHg
    {0x0E,0x11,0x11,0x0F,0x01,0x01,0x0E,0x00},  // 06: U ̃tHg
    {0x02,0x02,0x02,0x04,0x08,0x10,0x1F,0x00},  // 07: V ̃tHg
    {0x0E,0x11,0x11,0x0E,0x11,0x11,0x0E,0x00},  // 08: W ̃tHg
    {0x07,0x08,0x10,0x1E,0x11,0x11,0x0E,0x00},  // 09: X ̃tHg
    {0x11,0x11,0x1F,0x11,0x11,0x11,0x0E,0x00},  // 0A: ` ̃tHg
    {0x0F,0x11,0x11,0x0F,0x11,0x11,0x0F,0x00},  // 0B: a ̃tHg
    {0x0E,0x11,0x01,0x01,0x01,0x11,0x0E,0x00},  // 0C: b ̃tHg
    {0x07,0x09,0x11,0x11,0x11,0x09,0x07,0x00},  // 0D: c ̃tHg
    {0x1F,0x01,0x01,0x0F,0x01,0x01,0x1F,0x00},  // 0E: d ̃tHg
    {0x01,0x01,0x01,0x0F,0x01,0x01,0x1F,0x00},  // 0F: e ̃tHg
    {0x00,0x06,0x06,0x00,0x06,0x06,0x00,0x00},  // 10: F ̃tHg
    {0x00,0x06,0x06,0x00,0x00,0x00,0x00,0x00},  // 11: B ̃tHg
    {0x00,0x00,0x00,0x00,0x06,0x06,0x00,0x00},  // 12:  ̃tHg
    {0x00,0x00,0x04,0x0E,0x04,0x00,0x00,0x00},  // 13: +  ̃tHg
    {0x00,0x00,0x00,0x0E,0x00,0x00,0x00,0x00},  // 14: -  ̃tHg
    {0x00,0x20,0x10,0x08,0x04,0x02,0x01,0x00},  // 15: ^ ̃tHg
    {0x00,0x23,0x13,0x08,0x1C,0x1A,0x01,0x00},  // 16:  ̃tHg
    {0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00},  // 17: @ ̃tHg
    {0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00},  // 18: @ ̃tHg
    {0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00},  // 19: @ ̃tHg
    {0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00},  // 1A: @ ̃tHg
    {0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00},  // 1B: @ ̃tHg
    {0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00},  // 1C: @ ̃tHg
    {0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00},  // 1D: @ ̃tHg
    {0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00},  // 1E: @ ̃tHg
    {0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00}   // 1F: @ ̃tHg
};

volatile uint8_t    led_data[LEDDIG][2] =
{   /* MAX7219p\f[^ݒe[u : { LED,f[^ } */
    {Digit0,0x00},                  /* LED#0̐ݒf[^(,f[^j    */
    {Digit0,0x00},                  /* LED#1̐ݒf[^(,f[^j    */
    {Digit0,0x00},                  /* LED#2̐ݒf[^(,f[^j    */
    {Digit0,0x00}                   /* LED#3̐ݒf[^(,f[^j    */
};

volatile uint8_t    bit_data[LEDDIG][8] =
{   /* LED ̊e̕\p^[̃f[^ */
    {0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00},  /* LED#0̃f[^        */
    {0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00},  /* LED#1̃f[^        */
    {0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00},  /* LED#2̃f[^        */
    {0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00}   /* LED#3̃f[^        */
};

volatile uint8_t    disp_data[LEDDIG] =
{   /* LED ̊e̕\p^[̃f[^ */
    0x1F,                           /* LED#0̕\f[^                    */
    0x1F,                           /* LED#1̕\f[^                    */
    0x1F,                           /* LED#2̕\f[^                    */
    0x1F                            /* LED#3̕\f[^                    */
};

volatile uint16_t   count = 0x0000; /* \f[^pJE^             */

volatile uint8_t    g_digit;        /* wpϐ                     */

void R_wait_SW(void);               /* SW̉҂                 */
void R_wait_100ms(uint16_t);        /* 100ms҂                        */
void R_wait_1s(uint8_t);            /* 1bPʂł̎ԑ҂              */
void R_get_FONT(void);              /* \f[^ptHg쐬         */
void R_send_DATA(void);             /* \f[^M                   */


void R_MAIN_UserInit(void);

void main(void);


/***********************************************************************
* Function Name: main
* Description  : This function implements main function.
* Arguments    : None
* Return Value : None
************************************************************************/
void main(void)
{

    R_MAIN_UserInit();

  {

    uint8_t work;
    uint8_t i;

    R_wait_1s(1);               // 1s҂
    R_wait_SW();                // SW̉҂

/*----------------------------------------------------
    MAX7219̏s
        @DispTFfBXvCeXg[h
        AShutDFX^oC[h
        BDecModeFfR[h[h
        CIntendFLED̋Pxݒ
        DScanLFXL͈͂ݒ
        ENo_OPFMAX7219̏p
----------------------------------------------------*/

    for ( i = 0 ; i < 9 ; i++ )
    {

        // 7219̏R}hM
        work = R_CSI_Tx( (uint8_t *)&INIT1[i][0],0x02 );


        NOP();

        while ( work )
        {   // 肦ȂAG[̏

            LED1 =0;            // G[ȂLED1_
            HALT();             // G[ȂHALTŒ~

        }

    }/* End of 7219 Initialise  */

    NOP();


    while (1U)
    {

        uint16_t work;

        work = count;           // oߎԂǂݏo

        disp_data[3] = ( work / 1000 ); // ̌o
        work = ( work % 1000 );
        disp_data[2] = ( work / 100 );  // Šo
        work = ( work % 100 );
        disp_data[1] = ( work / 10 );   // \̌o
        disp_data[0] = ( work % 10 );   // ŉʌo

        ++count;                // oߎԂJEg

        if ( count >= 10000 )
        {
            count = 0x0000;
        }

        R_get_FONT();           // tHgf[^WJ

        R_send_DATA();          // LEDɕ\f[^𑗐M


        R_wait_1s(1);           // 1s҂

    }/* End of while loop   */

  }

}/* End  of main Function   */


/***********************************************************************
* Function Name: R_MAIN_UserInit
* Description  : This function adds user code before main function.
* Arguments    : None
* Return Value : None
************************************************************************/
void R_MAIN_UserInit(void)
{

    R_CSI00_Start();            /* CSI00̓싖                      */

    EI();                       /* CSI00ʐMs߂Ɋ荞݋    */

}/* End of R_MAIN_UserInit Function */


/************************************************************************
* Function Name: R_wait_SW
* Description  : SW̉҂
* Arguments    : None
* Return Value : None
*************************************************************************/
void R_wait_SW(void)
{

    LED2 = 0;                   // RL78/G15-FPBLED2_

    while ( 0 == USER_SW )
    {   // SWĂԂ҂

        NOP();

    }
    
    R_wait_100ms(1);            // 100ms҂
    
    while ( 1 == USER_SW )
    {   // SŴ҂

        NOP();

    }
    
    R_wait_100ms(1);            // 100ms҂

    LED2 = 1;                   // RL78/G15-FPBLED2

}/* End of R_wait_SW Function   */


/************************************************************************
* Function Name: R_wait_100ms
* Description  : 100ms̎Ԃ҂
* Arguments    : 100msPʂł̑҂
* Return Value : None
*************************************************************************/
void R_wait_100ms(uint16_t time)
{
    uint16_t twork;

    ITIF = 0;                   // 12bit IT 荞ݗvNA
    ITMK = 1;                   // 12bit IT 荞ݗv}XNi֎~j

    ITMC |= 0x8000;             // 12bit IT X^[g

    for ( twork = 0 ; twork < time ; twork++ )
    {

        while ( ITIF == 0 )
        {   // 100ms҂

            NOP();

        }

        ITIF = 0;

    }

    ITMC &= 0xFFF;              // 12bit IT ~
    ITIF = 0;

}/* End of R_wait_100ms Function    */


/************************************************************************
* Function Name: R_wait_1s
* Description  : 1s̎Ԃ҂
* Arguments    : time : 1bPʂ̑҂
* Return Value : None
*************************************************************************/
void R_wait_1s(uint8_t time)
{

    uint8_t loop;
    
    for ( loop = 0 ; loop < time ; loop++ )
    {   // 1s҂
        R_wait_100ms(10);
    }

}/* End of R_wait_1s Function   */


/************************************************************************
* Function Name: R_get_FONT
* Description  : \f[^(zdisp_data)̃tHgzbit_dataɐݒ
* Arguments    : None
* Return Value : None
*************************************************************************/
void R_get_FONT(void)
{
    uint8_t work,i,j;
/*----------------------------------------------------
        \f[^̃tHgf[^ǂݏo
----------------------------------------------------*/
    for ( i = 0 ; i < 4 ; i++ )         /* 4̃f[^Ώ        */
    {
        work = (0x1F & disp_data[i]);   /* \f[^ǂݏo          */

        for ( j = 0 ; j < 8 ; j++ )
        {   /* tHgf[^̃Rs[   */

            bit_data[i][j] = FONT_DATA[work][j];

        }

    }

}/* Endo of R_get_FONT Function */


/************************************************************************
* Function Name: R_send_DATA
* Description  : Mpzbit_data𑗐M
* Arguments    : digit
* Return Value : None
*************************************************************************/
void R_send_DATA(void)
{
    uint8_t i,j,work;

    for ( i = 0 ; i < 8 ; i++ )         /* LEĎXL            */
    {

        for ( j = 0 ; j < 4 ; j++ )     /* LED̃XL                */
        {

            led_data[j][0] = i+1;       /* LEĎݒ                */
            led_data[j][1] = bit_data[j][i]; /* tHgf[^ݒ      */

        }
                
        work = R_CSI_Tx( (uint8_t *)&led_data[0][0],0x08 );
        
        while ( work )
        {

            LED1 = 0;
            HALT();         /* G[ȂHALTŒ~i肦Ȃj*/

        }

    }/* End of LEĎXL  */

}/* End o R_send_DATA Function  */

